#
# Conditional build:
%bcond_without	metis		# partition support (using metis lib)

# main package version
%define		suite_ver	5.13.0
# see */Include/*.h /VER(SION)?_CODE
%define		amd_ver		2.4.6
%define		colamd_ver	2.9.6
%define		sliplu_ver	1.0.2

Summary:	SLIP_LU: Sparse Left-looking Integer-Preserving LU factorization
Summary(pl.UTF-8):	SLIP_LU - lewostronny rozkład LU dla macierzy rzadkich zachowujący liczby całkowite
Name:		SuiteSparse-SLIP_LU
Version:	%{sliplu_ver}
Release:	9
License:	LGPL v3+, GPL v2+
Group:		Libraries
#Source0Download: https://github.com/DrTimothyAldenDavis/SuiteSparse/releases
Source0:	https://github.com/DrTimothyAldenDavis/SuiteSparse/archive/v%{suite_ver}/SuiteSparse-%{suite_ver}.tar.gz
# Source0-md5:	e9e7bc594b77ae4b58d943cdc286d679
Patch0:		SuiteSparse-config.patch
Patch1:		SuiteSparse-amdf77.patch
Patch2:		SuiteSparse-externc.patch
Patch3:		SuiteSparse-ILP32.patch
URL:		http://suitesparse.com/
BuildRequires:	SuiteSparse-AMD-devel >= %{amd_ver}
BuildRequires:	SuiteSparse-COLAMD-devel >= %{colamd_ver}
BuildRequires:	SuiteSparse-config-devel >= %{suite_ver}
BuildRequires:	blas-devel
BuildRequires:	gcc-fortran
BuildRequires:	gmp-devel
BuildRequires:	lapack-devel
BuildRequires:	libgomp-devel
BuildRequires:	libstdc++-devel
BuildRequires:	libtool >= 2:1.5
%if %{with metis}
BuildRequires:	metis-devel >= 5
%endif
BuildRequires:	mpfr-devel
Requires:	SuiteSparse-AMD >= %{amd_ver}
Requires:	SuiteSparse-COLAMD >= %{colamd_ver}
Requires:	SuiteSparse-config-libs >= %{suite_ver}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
SLIP_LU is software package used to solve a sparse systems of linear
equations exactly using the Sparse Left-looking Integer-Preserving LU
factorization.

%description -l pl.UTF-8
SLIP_LU to pakiet służący do dokładnego rozwiązywania rzadkich układów
równań liniowych przy użyciu lewostronnego rzadkiego rozkładu LU
zachowującego liczby całkowite.

%package devel
Summary:	Header file for SLIP_LU library
Summary(pl.UTF-8):	Plik nagłówkowy biblioteki SLIP_LU
Version:	%{sliplu_ver}
Group:		Development/Libraries
Requires:	%{name} = %{sliplu_ver}-%{release}
Requires:	SuiteSparse-config-devel >= %{suite_ver}
Requires:	gmp-devel
Requires:	mpfr-devel

%description devel
Header file for SLIP_LU library.

%description devel -l pl.UTF-8
Plik nagłówkowy biblioteki SLIP_LU.

%package static
Summary:	Static SLIP_LU library
Summary(pl.UTF-8):	Statyczna biblioteka SLIP_LU
Version:	%{sliplu_ver}
Group:		Development/Libraries
Requires:	%{name}-devel = %{sliplu_ver}-%{release}

%description static
Static SLIP_LU library.

%description static -l pl.UTF-8
Statyczna biblioteka SLIP_LU.

%prep
%setup -q -n SuiteSparse-%{suite_ver}
%patch -P0 -p1
%patch -P1 -p1
%patch -P2 -p1
%ifnarch %{x8664} aarch64 alpha mips64 ppc64 s390x sparc64
%patch -P3 -p1
%endif

%build
%{__make} -C SLIP_LU -j1 \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	CFLAGS="%{rpmcflags}" \
	CXXFLAGS="%{rpmcxxflags}" \
	F77=gfortran \
	FFLAGS="%{rpmcflags}" \
	LDFLAGS="%{rpmldflags} -L$(pwd)/lib" \
	%{!?with_metis:CHOLMOD_CONFIG=-DNPARTITION} \
	CUDA=no \
	%{?with_metis:MY_METIS_LIB=-lmetis MY_METIS_INC=%{_includedir}}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_libdir},%{_includedir}/suitesparse,%{_datadir}/misc}

%{__make} -C SLIP_LU -j1 install \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	CFLAGS="%{rpmcflags}" \
	CXXFLAGS="%{rpmcxxflags}" \
	F77=gfortran \
	FFLAGS="%{rpmcflags}" \
	LDFLAGS="%{rpmldflags} -L$RPM_BUILD_ROOT%{_libdir}" \
	CUDA=no \
	INSTALL=$RPM_BUILD_ROOT%{_prefix} \
	INSTALL_INCLUDE=$RPM_BUILD_ROOT%{_includedir}/suitesparse \
	INSTALL_LIB=$RPM_BUILD_ROOT%{_libdir} \
	MY_METIS_LIB=-lmetis

cp -p SLIP_LU/Lib/lib*.a $RPM_BUILD_ROOT%{_libdir}

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc SLIP_LU/README.md SLIP_LU/License/license.txt
%attr(755,root,root) %{_libdir}/libsliplu.so.*.*.*
%ghost %{_libdir}/libsliplu.so.1

%files devel
%defattr(644,root,root,755)
%{_libdir}/libsliplu.so
%{_includedir}/suitesparse/SLIP_LU.h

%files static
%defattr(644,root,root,755)
%{_libdir}/libsliplu.a
%changelog
* Mon Jun 30 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/SuiteSparse-SLIP_LU.git;a=log;h=master

* Sun Jun 29 2025 Jakub Bogusz <qboosh@pld-linux.org> caabd4b
- last version of SuiteSparse SLIP_LU library from SuiteSparse 5.13.0

